# Secrets and Build Config

AppKickstarter leverages [BuildKonfig](https://github.com/yshrsmz/BuildKonfig) to store secrets and dispatch them in all platforms.

For example we have in local.properties this secret:&#x20;

```
# Google Sign in
google_sign_in_web_client_id=
```

In Shared module (build.gradle file) we get the local.properties secrets and create usable constants:&#x20;

```
buildkonfig {
    packageName = "com.appkickstarter.shared"

    val props = Properties()

    try {
        props.load(file("../local.properties").inputStream())
    } catch (e: Exception) {
        // keys are private and can not be committed to git
    }

    defaultConfigs {
        buildConfigField(
            STRING,
            "GOOGLE_SIGN_IN_WEB_CLIENT_ID",
            props["google_sign_in_web_client_id"]?.toString() ?: ""
        )
    }
}
```

This way we can use in Kotlin code (multiplatform) :&#x20;

```
private fun initGoogleAuth() {
    val credentials = GoogleAuthCredentials(serverId = BuildKonfig.GOOGLE_SIGN_IN_WEB_CLIENT_ID)
    ...
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.appkickstarter.com/tech-things/secrets-and-build-config.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
